using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;

namespace Ld31
{
    public class Controls : Root
    {
        public delegate void DeselectAction();

        static public event EventHandler OnCancelInteraction;
        static public event EventHandler OnCancel;

        private Vector3 dragStart = Vector3.zero;
        private bool dragging = false;

        public bool GetHold()
        {
            if ((int)Input.GetAxis("Fire1") == 1 && !GetDown())
                return true;
            return false;
        }

        public bool GetDrag()
        {
            if (GetHold() && (Input.mousePosition - dragStart).magnitude > 0.01f)
                return true;
            return false;
        }

        public bool GetDown()
        {
            return Input.GetMouseButtonDown(0);
        }

        public bool GetTrigger()
        {
            return Input.GetMouseButtonUp(0);
        }

        public bool GetPause()
        {
            if (Input.GetKey(KeyCode.Space))
                return true;
            return false;
        }

        public bool GetCommand()
        {
            if (Input.GetKey(KeyCode.LeftControl) || Input.GetKey(KeyCode.RightControl) || Input.GetKey(KeyCode.LeftCommand) || Input.GetKey(KeyCode.RightCommand))
                return true;
            return false;
        }

        public bool GetAlt()
        {
            if (Input.GetKey(KeyCode.LeftShift) || Input.GetKey(KeyCode.RightShift))
                return true;
            return false;
        }

        public bool GetShift()
        {
            if (Input.GetKey(KeyCode.LeftShift) || Input.GetKey(KeyCode.RightShift))
                return true;
            return false;
        }

        public bool GetCancel()
        {
            if (Input.GetMouseButtonUp(1) || Input.GetKeyUp(KeyCode.Escape))
                return true;
            return false;
        }

        private void Update()
        {

/*            if (Input.GetKeyUp(KeyCode.Plus) || Input.GetKeyUp(KeyCode.KeypadPlus))
                Game.Clock.Faster();

            if (Input.GetKeyUp(KeyCode.Minus) || Input.GetKeyUp(KeyCode.KeypadMinus))
                Game.Clock.Slower();*/

            if (GetDown())
                dragStart = Input.mousePosition;

            if (GetCancel() && GetHold())
            {
                // cancel interaction
                if (OnCancelInteraction != null)
                    OnCancelInteraction(this, EventArgs.Empty);
            }
            else if (GetCancel())
            {
                // cancel
                if (OnCancel != null)
                    OnCancel(this, EventArgs.Empty);
            }


        }
    }
}