﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

namespace Ld31
{
    public enum Ressources
    {
        Wood,
        Stone,
        Steel,

        Grain,
        Meat,
        Spices,

        Tools,
        Toys,
        Jewels,

        Manual,
        Service,
        Specialized
    }

    public class Economy : Root
    {
        //public int Population = 0;

        public int PopulationMax = 0;
        public Dictionary<string, int> Inventory;

        // Update is called once per frame
        void Update()
        {

        }

        void Start()
        {
            Inventory = new Dictionary<string, int>()
            {
                { "Wood", 300 },
                { "Stone", 5 },
                { "Steel", 0 },

                { "Grain", 150 },
                { "Meat", 0 },
                { "Spices", 0 },

                { "Tools", 5 },
                { "Toys", 0 },
                { "Jewels", 0 },

                { "Manual", 150 },
                { "Skilled", 0 },
                { "Specialized", 0 }       
            };
        }

        public int Population
        {
            get
            {
                var pop = 0;
                foreach (var each in Game.Map._AllStructures)
                    if (each.Type == StructureType.House && each.IsActive)
                        pop += each.ProducedRessources.Items["Manual"] + each.ProducedRessources.Items["Skilled"] + each.ProducedRessources.Items["Specialized"];
                if (!Game.Ui.firstBuildingPlaced || Time.time < 300) {
                    pop += 1;
                }
                if (pop > PopulationMax)
                    PopulationMax = pop;
                return pop;
            }
        }

        public int GetDemand(string key)
        {
            int supply = 0;
            int demand = 0;
            foreach (var each in Game.Map._AllStructures)
            {
                if (each.Type != StructureType.PowerUp && each.IsActive)
                {
                    demand += each.ConsumedRessources.Items[key];
                    supply += each.ProducedRessources.Items[key];
                }
            }
            return supply - demand;
        }
    }
}