﻿using System;
using UnityEngine;

namespace Ld31
{
    [RequireComponent(typeof(Config))]
    public class Game : Root
    {
        public MapGenerator Map;
        public Config Config;
        public Interface Ui;
        public Controls Controls;
        public Camera View;
        public Economy Economy;
        public Clock Clock;
        public AudioEngine Audio;
        public TitleScreen TitleScreen;

        void Start()
        {
            Cursor.SetCursor(Game.Config.CursorTexture, new Vector2(0, 0), CursorMode.Auto);
        }

        void OnGui()
        {
            //GUI.Label(new Rect(Input.mousePosition.x, Input.mousePosition.y, 16, 16), Game.Config.CursorTexture);
        }

        static public Texture2D ColorTex(Color color, int width, int height)
        {
            Texture2D tex = new Texture2D(width, height);
            Color[] colors = new Color[width * height];
            for (int i = 0; i < colors.Length; i++)
                colors[i] = color;
            tex.SetPixels(colors);
            tex.Apply();
            return tex;
        }
    }
}

