﻿using UnityEngine;
using System.Collections;
using System;

namespace Ld31
{
    public class Interface : Root
    {
        public static event EventHandler OnBlocked;

        public Toolbar Toolbar;
        public Zeiger Zeiger;
        public EntitySelection Selection;
        bool dragged = false;
        Vector3 dragStart;
        public bool firstBuildingPlaced = false;

        // Use this for initialization
        void Start()
        {
	
        }
	
        // Update is called once per frame
        void Update()
        {
            if (Game.Ui.Toolbar.IsMouseOnGUI())
            {
                // ...
            }
            else
            {
                OnWorld();
            }
        }

        void OnWorld()
        {

            // ==== TOOLS ====================================================================

            // If we have a tool selected
            if (Game.Ui.Toolbar.Selected != null)
            {
                // ==== SINGLE PLACEMENT ========================================================

                // regular building, single placement
                if (Game.Ui.Toolbar.Selected.Type == ToolType.BUILDING)
                {
                    if (!Game.Ui.Toolbar.IsBlocked() && Game.Controls.GetTrigger())
                    {
                        Game.Map.AddStructure((int)Zeiger.x, (int)Zeiger.y, Toolbar.Selected.Prefab);
                    }
                    else
                    {
                        if (Game.Controls.GetTrigger() && OnBlocked != null)
                            OnBlocked(this, EventArgs.Empty);
                    }
                }

                // ==== REMOVAL ========================================================

                // mark building for removal
                if (Game.Ui.Toolbar.Selected.Type == ToolType.REMOVAL)
                {
                    // Setup area removal on drag
                    if (Game.Controls.GetTrigger())
                    {
                        Game.Map.RemoveStructure(Zeiger.x, Zeiger.y);
                    }
                }

                // ==== COMMAND ========================================================
                // to be implemented (direct control of agents)
                return;
            }

            // ==== ENTITIY SELECTION ========================================================

            // no tool selected -> default to selecting/inspecting stuff in the world
            if (Game.Controls.GetDown())
            {
                dragged = false;
                dragStart = Input.mousePosition;
            }

            if (Game.Controls.GetDrag())
            {
                dragged = true;
                Selection.Try(Game.View, dragStart, Input.mousePosition);
            }

            // Collect PowerUps
            if (
                Game.Controls.GetTrigger() &&
                Game.Map._Data[Zeiger.x, Zeiger.y].InRange &&
                Game.Map.IsColliding(Zeiger.x, Zeiger.y) &&
                Game.Map._Data[Zeiger.x, Zeiger.y].Structure.Type == StructureType.PowerUp)
            {
                Game.Map._Data[Zeiger.x, Zeiger.y].Structure.Collect();
            }

            if (Game.Controls.GetTrigger() && !dragged)
            {
                //SetInspector();
                Selection.Try(Game.View, Input.mousePosition);
            }
        }

    }
}