﻿using UnityEngine;
using System.Collections;
using System.Linq;

namespace Ld31
{
    public class InventoryList : Root
    {
        private Texture2D barTexture;

        // Use this for initialization
        void Start()
        {
            barTexture = Game.ColorTex(new Color(222, 222, 222), 100, 10);
        }
	
        // Update is called once per frame
        void Update()
        {
	
        }

        void OnGUI()
        {
            var c1 = 48;
            var cw1 = 120;
            var c2 = c1 + cw1 + 8;
            var cw2 = 64;
            var c3 = c2 + cw2 + 8;
            var cw3 = 36;
            var c4 = c3 + cw3 + 8;
            var cw4 = 196;
            var c5 = c4 + cw4 + 8;
            var cw5 = 36;

            var box = 24;
            var lh = 16;
            var yOff = 64;
            GUI.skin = Game.Config.Skin;

            GUI.Label(new Rect(c1, yOff, cw1, box), "");
            GUI.Label(new Rect(c2, yOff, cw1, box), "Supply");
            GUI.Label(new Rect(c3 + 8, yOff, cw1, box), "Change");
            yOff += lh + 4;

            foreach (var each in Game.Economy.Inventory)
            {
                if (new[]{ "Wood", "Stone", "Steel" }.Contains(each.Key) && each.Value > 0)
                    GUI.Box(new Rect(c2, yOff + 4, Mathf.Log(each.Value) * 8, 14), "");
                if (new[]{ "Grain", "Meat", "Spices" }.Contains(each.Key) && each.Value > 0)
                    GUI.Box(new Rect(c2, yOff + 4, Mathf.Log(each.Value) * 8, 14), "");
                if (new[]{ "Manual", "Skilled", "Specialzed" }.Contains(each.Key) && each.Value > 0)
                    GUI.Box(new Rect(c2, yOff + 4, Mathf.Log(each.Value) * 8, 14), "");
                if (new[]{ "Tools", "Toys", "Jewels" }.Contains(each.Key) && each.Value > 0)
                    GUI.Box(new Rect(c2, yOff + 4, Mathf.Log(each.Value) * 8, 14), "");
                GUI.Label(new Rect(c1, yOff, cw1, box), each.Key);
                GUI.Label(new Rect(c2, yOff, cw2, box), "" + each.Value);
                if (Game.Ui.Toolbar.Selected != null && Game.Ui.Toolbar.Selected.Structure != null)
                {
                    if (Game.Ui.Toolbar.Selected.Structure.BuildRessources.Items[each.Key] > 0)
                    {
                        if (each.Value < Game.Ui.Toolbar.Selected.Structure.BuildRessources.Items[each.Key])
                            GUI.Label(new Rect(c4, yOff, cw4, box), "<color=#e6420f>-" + Game.Ui.Toolbar.Selected.Structure.BuildRessources.Items[each.Key] + "</color> to Build");
                        else
                            GUI.Label(new Rect(c4, yOff, cw4, box), "<color=#d5b47b>-" + Game.Ui.Toolbar.Selected.Structure.BuildRessources.Items[each.Key] + "</color> to Build");
                    }
                    if (Game.Ui.Toolbar.Selected.Structure.ConsumedRessources.Items[each.Key] > 0)
                        GUI.Label(new Rect(c3, yOff, cw3, box), "<color=#d5b47b>-" + Game.Ui.Toolbar.Selected.Structure.ConsumedRessources.Items[each.Key] + "</color>");
                    if (Game.Ui.Toolbar.Selected.Structure.ProducedRessources.Items[each.Key] > 0)
                        GUI.Label(new Rect(c3, yOff, cw3, box), "<color=#7bd5bf>+" + Game.Ui.Toolbar.Selected.Structure.ProducedRessources.Items[each.Key] + "</color>");
                }
                else
                {
                    var demand = Game.Economy.GetDemand(each.Key);
                    if (demand < 0 && each.Value == 0)
                        GUI.Label(new Rect(c3 + 8, yOff, cw3, box), "<color=#e6420f>" + demand + "</color>");
                    else if (demand == 0)
                        GUI.Label(new Rect(c3 + 8, yOff, cw3, box), "");
                    else if (demand < 0)
                        GUI.Label(new Rect(c3 + 8, yOff, cw3, box), "<color=#d5b47b>" + demand + "</color>");
                    else
                        GUI.Label(new Rect(c3 + 8, yOff, cw3, box), "<color=#7bd5bf>+" + demand + "</color>");
                }

                yOff += lh;
            }
            yOff += lh;

            GUI.Label(new Rect(c1, yOff, cw1, box), "Population: ");
            GUI.Label(new Rect(c2, yOff, cw2, box), "" + Game.Economy.Population);

        }
    }
}