using UnityEngine;
using System.Collections;

namespace Ld31
{
    [RequireComponent(typeof(SpriteRenderer))]
    public class Zeiger : Root
    {
        public Sprite Normal;
        public Sprite Blocked;
        SpriteRenderer spriteRenderer;

        public int x
        {
            get
            {
                return Mathf.Clamp((int)Camera.main.ScreenToWorldPoint(Input.mousePosition).x, 0, Game.Config.Width);
            }
        }

        public int y
        {
            get
            {
                return Mathf.Clamp((int)Camera.main.ScreenToWorldPoint(Input.mousePosition).y, 0, Game.Config.Height);
            }
        }

        void Start()
        {
            spriteRenderer = GetComponent<SpriteRenderer>();
        }

        void Update()
        {
            transform.position = new Vector3(x, y, -2);

            if (Game.Ui.Toolbar.IsMouseOnGUI())
                spriteRenderer.enabled = false;
            else
                spriteRenderer.enabled = true;

            if (Game.Ui.Toolbar.Selected != null && Game.Ui.Toolbar.Selected.Structure != null && Game.Ui.Toolbar.IsBlocked())
                spriteRenderer.sprite = Blocked;
            else
                spriteRenderer.sprite = Normal;

        }

        void OnGUI () {
            if (!Game.Ui.Toolbar.IsMouseOnGUI())
            {
                GUI.skin = Game.Config.Skin;
                var pos = Camera.main.WorldToScreenPoint(new Vector3(x, y, -3));
                GUI.Label(new Rect(pos.x, Screen.height - pos.y - 36, 500, 24), Game.Ui.Toolbar.GetTooltip());
            }
        }
    }

}